<template>
  <template-page
    ref="pageRef"
    :getList="getList"
    :exportList="exportList"
    :operation="operation()"
    :optionsEvensGroup="optionsEvensGroup"
    :columnParsing="columnParsing"
  >
  </template-page>
</template>

<script>
import TemplatePage from '@/components/template/template-page-1.vue'
import import_mixin from '@/components/template/import_mixin.js'
import add_callback_mixin from '@/components/template/add_callback_mixin.js'
import Popu from '@/components/template/popu.vue'
import { getPurchaseOutListV2, setApprovalPurchaseOrderOut, exportPurchaseOutListV2 } from '@/api/supply/purchase'
import { getWarehouseList } from '@/api/supply/apply'
import { thisExpression } from '@babel/types'
export default {
  components: { TemplatePage, Popu },
  mixins: [import_mixin, add_callback_mixin],
  data() {
    return {
      visible: false,
      // 事件组合
      optionsEvensGroup: [
        //  [
        //     [
        //       {
        //         name: '导入',
        //         render: this.importButton(importCustomerV2)
        //       }
        //     ]
        //   ],
      ],
      // 表格属性
      tableAttributes: {
        // 启用勾选列
        selectColumn: true
      }, // 关闭新增弹窗

      // 表格事件
      tableEvents: {
        'selection-change': this.selectionChange
      },
      recordSelected: [],
      currentPage: 1, // 当前页码
      pageSize: 10, // 每页数量
      listTotal: 0, // 列表总数
      dataList: null, // 列表数据
      listLoading: false, // 列表加载loading
      screenForm: {
        billNo: '',
        correspondId: [],
        endTime: '',
        date: [],
        materialName: '',
        materialNumber: '',
        materialOldNumber: '',
        specification: '',
        startTime: '',
        supplierName: ''
      },
      isCollapse: true,
      warehouseList: []
    }
  },
  methods: {
    // 列表请求函数
    getList(...p) {
      this.recordSelected = []
      return getPurchaseOutListV2(...p)
    },
    // 列表导出函数
    exportList: exportPurchaseOutListV2,
    // 表格列解析渲染数据更改
    columnParsing(item, defaultData) {
      return defaultData
    },
    // 监听勾选变化
    selectionChange(data) {
      this.recordSelected = data
    },
    operation() {
      return (h, { row, index, column }) => {
        return (
          <div class="operation-btns">
            <el-popconfirm title="弃审吗？" onOnConfirm={() => this.handleUnapprove(row.id, row.billNo)}>
              <el-button slot="reference" type="text" size="mini">
                弃审
              </el-button>
            </el-popconfirm>
          </div>
        )
      }
    },
    handleClose() {
      this.addOff(() => {
        this.visible = false
      })()
    },
    // 获取仓库列表
    getWarehouseList() {
      getWarehouseList({
        pageNum: 1,
        pageSize: -1
      }).then(res => {
        this.warehouseList = res.data.records
      })
    },
    handleUnapprove(id, billNo) {
      setApprovalPurchaseOrderOut({ id, billNo }).then(res => {
        this.$successMsg('弃审成功')
        this.$refs.pageRef.refreshList()
      })
    }
  }
}
</script>

<style lang="scss" scoped></style>
